hdu4288 coder

Coder

Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 6713    Accepted Submission(s): 2494


 

Problem Description

  In mathematics and computer science, an algorithm describes a set of procedures or instructions that define a procedure. The term has become increasing popular since the advent of cheap and reliable computers. Many companies now employ a single coder to write an algorithm that will replace many other employees. An added benefit to the employer is that the coder will also become redundant once their work is done. 1
  You are now the signle coder, and have been assigned a new task writing code, since your boss would like to replace many other employees (and you when you become redundant once your task is complete).
Your code should be able to complete a task to replace these employees who do nothing all day but eating: make the digest sum.
  By saying “digest sum” we study some properties of data. For the sake of simplicity, our data is a set of integers. Your code should give response to following operations:
  1. add x – add the element x to the set;
  2. del x – remove the element x from the set;
  3. sum – find the digest sum of the set. The digest sum should be understood by


  where the set S is written as {a1, a2, ... , ak} satisfying a1 < a2 < a3 < ... < ak
  Can you complete this task (and be then fired)?
------------------------------------------------------------------------------
1 See http://uncyclopedia.wikia.com/wiki/Algorithm  

Input

  There’re several test cases.
  In each test case, the first line contains one integer N ( 1 <= N <= 105 ), the number of operations to process.
  Then following is n lines, each one containing one of three operations: “add x” or “del x” or “sum”.
  You may assume that 1 <= x <= 109.
  Please see the sample for detailed format.
  For any “add x” it is guaranteed that x is not currently in the set just before this operation.
  For any “del x” it is guaranteed that x must currently be in the set just before this operation.
  Please process until EOF (End Of File).

 

Output

  For each operation “sum” please print one line containing exactly one integer denoting the digest sum of the current set. Print 0 if the set is empty.

 

Sample Input

 

9 add 1 add 2 add 3 add 4 add 5 sum add 6 del 3 sum 6 add 1 add 3 add 5 add 7 add 9 sum

 

Sample Output

 
3 4 5

Hint

C++ maybe run faster than G++ in this problem.  

Source

2012 ACM/ICPC Asia Regional Chengdu Online

 

Recommend

liuyiding   |   We have carefully selected several similar problems for you:  4297 4289 4290 4291 4292 

题解:

原来线段树还能这么合并。。真是涨姿势了

orz

题目大意:

有一个集合,每次操作都可以添加x,删除x,或者查询sum ,这个sum指的是在集合当中从小到大排序后,下标能够对5取模后等于3的数。如上公式。

题解:

因为x数很大,所以要离散化,离散化,那就是离线算法了。用线段树来维护每次操作后整段区间的符合条件的的值。在每个节点上有两个变量,一个num用来存储以该节点为根的树上有多少值,一个sum[5],用来存储在当前树上位置取模后为0、1、2、3、4的数的和。那么怎么将两颗左右子树合并到它的父节点上呢?先看一个数列:

(1 2 3 4 5 6 7   8 9 10 11 12)

(1 2 3 4 5 6 7 | 1 2 3 4 5 )假设这是由 ‘ | ’分隔开的左右子树,上面的数列是合并后的数列。在左子树上取模后为3的是3,他在合并后的数列上仍然是3。但是看右子树,取模后为3的也是3,但是当他合并后变成了10,而10取模后是0.也就说在子树合并的时候对于右子树sum[i]可以直接相加,而右子树的需要转化一下。这个可以推导一下,转化后为sum[(i-num[左子树]%5+5)%5],这样的话就可以合并了。最后直接求根节点的sun[3]也就是整个区间上对5取模后余3的和。

代码:

#include <cstdio>
#include <cstring>
#include <map>
#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;
struct node
{
    int id,x;
    char op[10];
}e[110005];
map<int,int>mp;
int val[110005];
long long sum[440005][5];
int  num[4400005];
bool cmp1(node a,node b)
{
    if(a.x==b.x)return a.op[0]<b.op[0];
    return a.x<b.x;
}
bool cmp2(node a,node b)
{
    return a.id<b.id;
}
void build(int root,int l,int r)
{
    num[root]=0;
    for(int i=0;i<5;i++)sum[root][i]=0;
    if(l==r)return ;
    int mid=(l+r)>>1;
    build(root<<1,l,mid);
    build(root<<1|1,mid+1,r);
}
void change(int root,int l,int r,int pos,int kis)
{
    if(l==r)
    {
        if(kis>0){
        num[root]=1;
        sum[root][1]=val[l];
        }
        else
        {
            num[root]=0;
            sum[root][1]=0;
        }
        return ;
    }
    int mid=(l+r)>>1;
    if(pos<=mid)
        change(root<<1,l,mid,pos,kis);
    else change(root<<1|1,mid+1,r,pos,kis);
    num[root]=num[root<<1]+num[root<<1|1];
    for(int i=0;i<5;i++)
    {
        sum[root][i]=sum[root<<1][i]+sum[root<<1|1][(i-num[root<<1]%5+5)%5];
    }
}
int main()
{
    int n,cnt;
    while(~scanf("%d",&n))
    {
        for(int i=0;i<n;i++)
        {
            scanf("%s",e[i].op);
            if(e[i].op[0]=='s')e[i].x=0;
            else scanf("%d",&e[i].x);
            e[i].id=i;
        }
        cnt=0;
        mp.clear();
        sort(e,e+n,cmp1);
        for(int i=0;i<n;i++)
        {
            if(!mp[e[i].x])
            {
                mp[e[i].x]=++cnt;
            }
            val[mp[e[i].x]]=e[i].x;
        }
        sort(e,e+n,cmp2);
        if(!cnt)
        {
            if(e[0].op[0]=='s')
                puts("0");
            continue;
        }
        //cout<<cnt<<endl;
        build(1,1,cnt);
        for(int i=0;i<n;i++)
        {
            if(e[i].op[0]=='a')
            {
                //cout<<mp[e[i].x]<<" "<<val[mp[e[i].x]]<<endl;
                change(1,1,cnt,mp[e[i].x],1);
            }
            else if(e[i].op[0]=='d')
            {
                change(1,1,cnt,mp[e[i].x],-1);
            }
            else
            {
                printf("%lld\n",sum[1][3]);
            }
        }
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/qq_41510496/article/details/81090080